Fri Feb 18 19:31:31 2011  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/fileutils.rb (FileUtils::remove_entry_secure): there is a
	  race condition in the case where the given path is a directory,
	  and some other user can move that directory, and create a
	  symlink while this method is executing.
	  Reported by: Nicholas Jefferson <nicholas at pythonic.com.au>

Sun Aug 15 19:59:58 2010  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* lib/webrick/httpresponse.rb (WEBrick::HTTPResponse#set_error):
	  Fix for possible cross-site scripting (CVE-2010-0541). 
	  Found by Apple, reported by Hideki Yamane.
	  Patch by Hirokazu Nishio <nishio.hirokazu AT gmail.com>.

Fri Jul  2 19:07:09 2010  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* io.c (argf_inplace_mode_set): prohibits an assignment
	  of a tainted value. Patch by unak.

	* util.c, file.c: prevents a buffer over-run on windows.
	  Patch by unak.

Wed May 26 13:27:18 2010  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* random.c: refactoring.

	* random.c (rand_srand): a new function that wraps
	  rand_init and (re)initialization of the random seed as
	  a VALUE.

	* random.c (genrand_int32, genrand_real, rb_f_rand,
	  rb_f_srand): using rand_srand.

Mon Mar 15 11:49:48 2010  NARUSE, Yui  <naruse@ruby-lang.org>

	* random.c (rb_reset_random_seed): set seed in this.
	  [ruby-core:28655]

Mon Jun 29 20:29:11 2009  Tadayoshi Funaba  <tadf@dotrb.org>

	* rational.c (float_to_r): always returns rational.

Sun Jul 19 20:41:24 2009  Tadayoshi Funaba  <tadf@dotrb.org>

	* complex.c (make_patterns): do not use \d.

	* rational.c (make_patterns): ditto.

Fri Apr 30 03:38:14 2010  NAKAMURA Usaku  <usa@ruby-lang.org>

	* numeric.c (fix_mul): the width of fixnum is same as long's on all
	  platforms.

Wed Aug 26 13:48:33 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/tempfile.rb (Tempfile#unlink): reverted r23494, since the
	  usage in RubyInline is considered wrong.

Tue Feb  9 23:48:25 2010  Yusuke Endoh  <mame@tsg.ne.jp>

	* ext/bigdecimal/bigdecimal.c (BigDecimal_divide): fix precision too.

Tue Feb  9 23:26:07 2010  Yusuke Endoh  <mame@tsg.ne.jp>

	* ext/bigdecimal/bigdecimal.c (BigDecimal_DoDivmod): fix precision.
	  [ruby-core:17472][ruby-dev:35372][ruby-dev:40105][ruby-dev:40358]

Thu Dec 10 01:12:55 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (dyna_pop_gen): pop dvars.  [ruby-dev:39861]

Sat Dec  5 13:19:29 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in: default ac_cv_prog_CC to CC.

Mon Feb  1 17:11:12 2010  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* string (rb_string_value): warning for implicit conversion
	  from Symbol to String. This behavior was introduced in r22606,
	  merged in r22738 to ruby_1_9_1. It was an unexpected language
	  feature change. It will be removed from Ruby in the 1.9.2.
	  c.f. [ruby-dev:40274].

Thu Feb 26 13:23:20 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* iseq.c (cdhash_each): resurrects internal literals.

Wed Feb 18 14:33:35 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (rb_ary_resurrect), string.c (rb_str_resurrect): new
	  functions based on [ruby-dev:37983]

	* insns.def (putstring, duparray): use rb_{ary,str}_resurrect().

	* iseq.c (iseq_data_to_ary): needs to result TS_VALUE.

Wed Dec  9 09:50:35 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_justify): fixed the case a fill size is a
	  multiple of the length of the padding.  [ruby-dev:39856]

Sat Oct 31 17:19:28 2009  NAKAMURA, Hiroshi  <nahi@ruby-lang.org>

	* lib/net/http.rb (Net::HTTPResponse#each_response_header):
	  cosmetic: '?\ ' -> '?\s'

Fri Oct 30 22:09:47 2009  NAKAMURA, Hiroshi  <nahi@ruby-lang.org>

	* lib/net/http.rb (Net::HTTPResponse#each_response_header):
	  accept multiline message header of HTTP response.  see #1796.
	  cf. RFC 2616 '4.2 Message Header'.  

	* test/net/http/test_httpresponse.rb: added.

Thu Oct 29 04:41:44 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* ruby.c (process_options): call rb_filesystem_encoding().

Wed Oct 28 16:32:49 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* encoding.c (get_filesystem_encoding): removed.

	* encoding.c (rb_locale_encindex): added.

	* encoding.c (rb_filesystem_encindex): added.

	* encoding.c (rb_filesystem_encindex): add an alias 'filesystem'.
	  [ruby-dev:39574]

	* encoding.c (enc_find): add rdoc about special aliases.

	* gem_prelude.rb (Gem.set_home): use Encoding.find('filesystem').

	* gem_prelude.rb (Gem.set_paths): ditto.

Wed Oct 28 15:02:31 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* gem_prelude.rb (Gem.set_home):
	  force_encoding(Encoding.filesystem_encoding)
	  [ruby-core:25959]

	* gem_prelude.rb (Gem.set_paths): ditto.

Wed Oct 28 14:24:45 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* encoding.c (get_filesystem_encoding):
	  add Encoding.filesystem_encoding [ruby-dev:39546]
	  also see [ruby-core:25959]

Tue Oct 27 15:44:48 2009  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/ftp.rb (getbinaryfile, list): call to_s to convert
	  a Pathname instance into a string.  [ruby-core:26237]

Tue Oct 27 07:53:25 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* gc.c (garbage_collect_with_gvl): do not garbage_collect when
	  dont_gc flag turned on.  [ruby-core:26327]

Tue Oct 27 05:56:39 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* vm.c (invoke_block_from_c): return Qnil when its iseq is
	  SPECIAL CONST. [ruby-core:26335]

Mon Oct 26 12:06:27 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (io_fwrite): adjust stdio file position after direct write on
	  BSDish platforms.   [ruby-core:26300]

Sun Oct 25 13:33:58 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (io_cntl): F_DUPFD is platform dependent.

Sat Oct 24 00:36:47 2009  Tanaka Akira  <akr@fsij.org>

	* io.c (io_cntl): update max file descriptor by the result of
	  fcntl(F_DUPFD).

Fri Oct 23 09:12:59 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/pathname.rb (Pathname::SAME_PATHS): FNM_SYSCASE is always
	  non-nil.

Thu Oct 22 20:20:27 2009  Tanaka Akira  <akr@fsij.org>

	* test/ruby/envutil.rb (assert_in_out_err): test_stdout and
	  test_stderr should be an array.

	* test/ruby/test_rubyoptions.rb (test_notfound): test_stdin of
	  assert_in_out_err should be a string.

Tue Oct 20 16:41:18 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* include/ruby/win32.h (finite, scalb): inline'ed non-standard
	  identifier macros.  [ruby-core:2234]

Tue Oct 20 15:38:02 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (ripper_intern): enable literal optimization.

	* parse.y (method_call): dispatch symbols.  a patch from Andy Keep in
	  [ruby-core:26169].  [ruby-core:26165]

	* parse.y (mlhs_basic): fixed handling splat in middle of mlhs.  a
	  patch from Andy Keep in [ruby-core:26163]

	* parse.y (parser_here_document): dispatch delayed heredoc
	  contents.  based on a patch from Andy Keep in [ruby-core:24855].

Sat Jan 30 18:09:36 2010  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* vm_method.c (rb_alias): treats an alias as if it is a newly defined
	  method so that oklass in a method cache refers the class on which the 
	  aliasing occured.
	  [ruby-core:26074] (#2202).

Sat Jan 30 17:58:28 2010  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* .gdbinit: follows r24470.

Mon Oct 19 05:49:53 2009  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/rexml/element.rb (text=): false should be converted to string.
	  A patch by Teruo Oshida [ruby-dev:38351]

Sun Oct 18 09:49:14 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* test/test_prime.rb
	  (TestPrime#test_eratosthenes_works_fine_after_timeout):
	  test for [ruby-dev:39465].

	* lib/prime.rb (Prime::EratosthenesSieve):
	  fixed [ruby-dev:39465].
	  suppressed memory reallocation.
	  constantified some magic numbers.

Fri Oct 17 00:05:53 2009  wanabe  <s.wanabe@gmail.com>

	* st.c (unpack_entries): save table->bins and never change the table
	  during unpacking. Because st_insert() may cause GC and refer the
	  table, i.e. st_foreach().  [Bug #2196]

Fri Oct 16 18:42:18 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* bootstraptest/test_gc.rb: added tests based on [ruby-dev:39484]
	  from wanabe <s.wanabe AT gmail.com>.

Thu Oct 15 14:20:58 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/iconv/iconv.c (iconv_create): cannot retry with given block.
	  [ruby-dev:39487]

Thu Oct 15 09:25:07 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

 * ext/socket/init.c (rsock_init_sock): mswin doesn't have S_IFSOCK
   flag in st_mode of struct stat. so, use rb_w32_issocket() function
   instead of S_ISSOCK macro.

Thu Oct 15 00:26:07 2009  Tanaka Akira  <akr@fsij.org>

	* ext/socket/init.c (rsock_init_sock): validate file descriptor.

Tue Oct 13 18:54:25 2009  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/variable.rb: bug fix. additional trace definition changes the
	  option of first trace definition.

Tue Oct 13 18:20:57 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_magic_comment): fixed normalization.

Mon Oct 12 23:27:57 2009  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/ftp.rb (login): use "anonymous@" as a default password.
	  [ruby-dev:39451]

Sun Oct 11 15:54:52 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/gdbm/gdbm.c (fgdbm_select): fixed rdoc.  a patch from Justin
	  Collins in [ruby-core:26050].

Sun Oct 11 10:27:09 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/irb/context.rb (IRB::Context#irb_name): removed duplicated
	  attr_reader.  [ruby-core:26047]

	* lib/irb/ruby-lex.rb (RubyLex#lex_int2): removed duplicated
	  character class range.

Sun Oct 11 09:04:08 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/ruby.h (RB_GC_GUARD_PTR): workaround for gcc
	  optimization.

	* include/ruby/ruby.h (ruby_exec_node): declared.

Sat Oct 10 23:57:44 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (path_check_0): prevent from GC.

Fri Oct  9 02:12:02 2009  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* ext/curses/curses.c: Many functions of module Curses could cause a
	  crash if the ncurses library was not properly initialized.
	  Fix pointed out by Alexander Beisig [ruby-core:22592]
	  Functions fixed: attroff, attron, attrset, bkgd, bkgdset,
	  can_change_color, close_screen, closed, color_content, curs_set,
	  def_prog_mode, delch, deleteln, getmouse, getstr, has_colors,
	  init_color, init_pair, insertln, keyname, mouseinterval, mousemask,
	  pair_content, pair_number, reset_prog_mode, resizeterm, scrl,
	  setscrreg, standend, standout, start_color, timeout, ungetmouse,
	  use_default_colors

Fri Oct  9 01:07:34 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* compile.c (ADD_TRACE): fire coverage event in ensure clause.
	  [ruby-dev:39303]

	* iseq.h, iseq.c: ditto.

Fri Oct  9 00:33:29 2009  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/net/telnet.rb (cmd): Pass FailEOF options: patch by Brian
	  Candler [ruby-core:22723]

Mon Oct  5 17:19:33 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/delegate.rb (Delegator::public_api): take snapshot of
	  public method at the beginning time.

	* lib/delegate.rb (SimpleDelegator#initialize): use
	  Delegator.public_api since public_method might be added after
	  initialization.  [ruby-dev:39383]

	* lib/delegate.rb (DelegateClass): ditto.

Tue Oct  6 18:56:09 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* struct.c (rb_struct_select): Struct#select should return
	  enumerator when no block given.

Sun Jan 10 17:25:24 2010  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/webrick/accesslog.rb : Escape needed.

	* lib/webrick/httpstatus.rb : ditto.

	* lib/webrick/httprequest.rb : ditto.

	* lib/webrick/httputils.rb : ditto.

	* test/webrick/test_cgi.rb (TestWEBrickCGI::test_bad_): Test for it.

Sat Dec  5 18:52:56 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* string.c (rb_str_justify): CVE-2009-4124.
	  Fixes a bug reported by 
	  Emmanouel Kellinis <Emmanouel.Kellinis AT kpmg.co.uk>, KPMG London;
	  Patch by nobu.

Sat Dec  5 14:29:49 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* lib/irb/extend-command.rb (IRB::ExtendCommandBundle::def_extend_command):
	  extension commands with optional parameters have been broken because of 
	  a spec change of UnboundMethod#arity.

Sat Dec  5 14:24:10 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* lib/irb/extend-command.rb (IRB::ExtendCommandBundle::def_extend_command):
	  gives eval a source location for readability of backtrace.

	* lib/irb/extend-command.rb (IRB::ContextExtender::def_extend_command):
	  ditto

	* lib/irb/extend-command.rb (IRB::MethodExtender::def_pre_proc):
	  ditto

	* lib/irb/extend-command.rb (IRB::MethodExtender::def_post_proc):
	  ditto

Tue Jul 21 21:37:19 2009  Keiju Ishitsuka  <keiju@emperor2.pendome>

	* lib/irb/cmd/help.rb: fixed irb's "help" command. [ruby-core:22310].

Thu Jul 23 14:35:02 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (rb_w32_{open,wopen}): fixed typos. these conditions
	  mean to call runtime's open() if textmode.

Fri Sep 25 16:01:45 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c, include/ruby/win32.h (rb_w32_access): new function to
	  replace MSVCRT's access().
	  [ruby-core:25761]

	* file.c (eaccess): workaround for recent MSVCRT is no longer needed.

Mon Sep 28 19:36:20 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/wini32.c (LK_ERR): with overlapped I/O, LockFileEx() returns
	  ERROR_IO_PENDING if the file is locked.

Mon Nov 23 04:12:00 2009  Tanaka Akira  <akr@fsij.org>

	* enc/trans/newline.trans (fun_so_universal_newline): generate \n
	  after \r\n detection instead of just after \r.
	  [ruby-list:45988] [ruby-core:25881] [ruby-core:26788]

Tue Dec  1 12:01:13 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (dyna_push_gen, dyna_pop_gen): no needs to save both of
	  args and vars.  [ruby-core:26961]

	* parse.y (dyna_push_gen): use rb_node_newnode() for ripper.
	  [ruby-core:26961]

	* parse.y (dyna_push_gen, dyna_pop_gen): adjust local vtable level
	  for the case of syntax errors in method name or argument inside
	  do block.   [ruby-core:26961]

Tue Oct 20 15:28:49 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (method_call): dispatch symbols.  a patch from Andy Keep in
	  [ruby-core:26169].  [ruby-core:26165]

	* parse.y (mlhs_basic): fixed handling splat in middle of mlhs.  a
	  patch from Andy Keep in [ruby-core:26163]
Thu Oct 15 16:57:38 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (rb_intern3): check symbol table overflow.
	  [ruby-core:26092]

Sun Oct 11 15:54:52 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/gdbm/gdbm.c (fgdbm_select): fixed rdoc.  a patch from Justin
	  Collins in [ruby-core:26050].

Sat Aug 22 01:29:29 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (rm_f, rm_rf): pass the last hash through if exists.
	  [ruby-dev:39153]

Tue Oct 20 14:50:51 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_here_document): dispatch delayed heredoc
	  contents.  based on a patch from Andy Keep in [ruby-core:24855].

Fri Jan 30 18:04:23 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (rb_w32_write): limit write size to 32KB if the file
	  seems to be console.  [ruby-core:21613]

Sat Oct  3 22:14:18 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (bv_decls, bvar): fix for block variables.
	  [ruby-dev:39423]

Sat Oct  3 00:47:52 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/ripper/dummyparser.rb (DummyParser): improvement by Magnus
	  Holm in [ruby-core:25884].
	  * remove scanner events which simply returned the first argument.
	  * all parser events are now automatically generated.
	  * simplify blocks.

Fri Oct  2 20:37:37 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (ripper_yylval_id, ripper_get_{id,value}): wrap ID by
	  NODE to track local variable assignment.

	* parse.y (lvar_defined_gen, assignable_gen): enable local
	  variable check.  [ruby-core:24923]

	* parse.y (validate): use value only.

	* test/ripper/test_parser_events.rb (test_local_variables): tests
	  based on a patch from Magnus Holm in [ruby-core:25885].

Fri Oct  2 15:34:15 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (ruby_suppress_tracing): get rid of clobbering by
	  longjmp.

Fri Oct 16 12:03:31 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/csv.rb (CSV#raw_encoding): returns ASCII-8BIT when the io
	  doesn't have encoding.

Fri Oct 16 03:15:52 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/csv.rb (CSV#read_to_char): set encoding and verify data
	  which read from io before encode it to @encoding.

	* lib/csv.rb (CSV#raw_encoding): add to get @io's encoding.

	* lib/csv.rb (CSV#read_io): add to read string and set @io's
	  encoding.

Mon Sep 28 22:33:11 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dln.c (aix_loaderror): needs format string.

Mon Sep 28 10:06:38 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* stringio/stringio.c (strio_read): set ASCII-8BIT encoding
	  when length argument is given.

Sun Sep 27 13:06:43 2009  Tanaka Akira  <akr@fsij.org>

	* lib/pp.rb (PP:ObjectMixin#pretty_print): delegates has no inspect
	  method.  [ruby-core:25804]

Sat Sep 26 08:35:12 2009  Koichi Sasada  <ko1@atdot.net>

	* iseq.c (compile_string): rename to parse_string(), because
	  this function only parse String to NODE.

Thu Sep 24 09:41:42 2009  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/mathn.rb (Bignum#**): Fixed bignum**fixnum that was broken when
	  requiring lib/mathn
	  [ruby-core:25740]

Tue Sep 22 05:04:08 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/bigdecimal/lib/bigdecimal/{ludcmp,math}.rb: depend on
	  bigdecimal.

	* ext/bigdecimal/lib/bigdecimal/*.rb: made module functions.

Tue Sep 22 01:10:02 2009  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* ossl_config.c (ossl_config_add_value_m, ossl_config_set_section):
	  Check if frozen (or untrusted for $SECURE >= 4) [ruby-core:18377]

Sun Sep 20 11:11:34 2009  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* struct.c (rb_struct_equal, rb_struct_eql): Handle comparison of
	  recursive structures [ruby-core:24759]

	* range.c (range_eq, range_eql):  ditto for ranges

Fri Sep 18 23:51:17 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* marshal.c (r_object0): entry regexp object before its encoding
	  name.  [ruby-core:25625]

Sun Aug 16 00:30:33 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* include/ruby/oniguruma.h
	  (ONIGENC_CTYPE_SPECIAL_MASK): added.
	  (ONIGENC_CTYPE_D): ditto.
	  (ONIGENC_CTYPE_S): ditto.
	  (ONIGENC_CTYPE_W): ditto.

	* regparse.c: \d, \s and \w are now non Unicode class.
	  [ruby-dev:39026]
	  (fetch_token_in_cc): use ONIGENC_CTYPE_[DSW] for \d/\s/\w.
	  (fetch_token): ditto.
	  (add_ctype_to_cc): add routines for ONIGENC_CTYPE_[DSW].
	  (parse_exp): ditto.

	* test/ruby/test_regexp.rb (TestRegexp#test_char_class):
	  add tests for above.

Fri Sep 18 16:15:04 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_compile_each), parse.y (stmt, arg): arg_concat()
	  on op_asgn was inversed.  [ruby-core:25629] [Bug #2050]

Sat Sep  5 15:21:13 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

 * compile.c (iseq_compile_each): op_asgn to aref should return rhs.
   [ruby-core:25387]

Sun Feb 15 03:50:21 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* hash.c (rb_hash): always return a fixnum value because a return
	  value of rb_hash may be used as a hash value itself and bignums have
	  no unique VALUE.

	* test/ruby/test_hash.rb: add a test for above.

Tue Nov 17 16:04:13 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* regparse.c (parse_char_class): fixes a wrong merge r25531.

Tue Nov 17 16:01:02 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* insns.def (opt_case_dispatch): need cast.

Tue Nov 17 15:46:23 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* dir.c (READDIR): this branch doesn't have rb_w32_readdir_with_enc().

Fri Sep 18 07:06:41 2009  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* test/fileutils/test_fileutils.rb: add a test for [ruby-dev:39345]

Fri Sep 18 06:36:51 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (rm_f, rm_rf): FileUtils.rm can take an array.
	  [ruby-dev:39345]

Thu Oct 29 01:22:01 2009  Yutaka Kanemoto  <kanemoto@ruby-lang.org>

	* ext/socket/extconf.rb : Compilation failure on AIX.
	  ss_len (a member of struct sockaddr_storage) has preceding __,
	  but ss_family does not have it from AIX 5.2.

Mon Sep 28 01:28:17 2009  Yutaka Kanemoto  <kanemoto@ruby-lang.org>

	* Makefile.in (miniruby): suppress duplication warning on AIX.

Mon Sep 28 01:13:25 2009  Yutaka Kanemoto  <kanemoto@ruby-lang.org>

	* common.mk (ruby.imp): add text section [Bug #2064].

	* common.mk (ruby.imp): do not export Init_*.

Thu Sep 24 01:14:18 2009  Yutaka Kanemoto  <kanemoto@ruby-lang.org>

	* dln.c (aix_loaderror): fixed typo. suppress warnings.

Sun Aug  9 16:36:51 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (ruby.imp): excluded prelude.o to get rid of circular
	  dependency.  [ruby-dev:39052]

Thu Sep 17 06:03:40 2009  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix.rb (Matrix#rank): Two bug fixes. One made
	  Matrix[[0,0],[0,0],[1,0]].rank raise a NoMethodError while the other
	  one had Matrix[[0,1],[0,0],[1,0]].rank raise a TypeError.

Wed Sep 16 17:20:49 2009  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix.rb (Matrix#/): Fix obvious bug

Wed Sep 16 13:39:10 2009  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix.rb (determinant): Bug fix where determinant failed on
	  some matrices [ruby-core:23597]

Mon Sep 14 06:42:21 2009  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/cgi/cookie.rb (value): Keep CGI::Cookie#value in sync with the
	  cookie itself. Based on a patch by Arthur Schreiber [ruby-core:17634]

Mon Sep 14 05:21:12 2009  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/net/http.rb (fetch): Handle properly default values; a patch by
	  Arthur Schreiber [ruby-core:18308]

Sun Sep 13 12:07:49 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/ruby.h (SYM2ID): needs parens.

	* include/ruby/ruby.h (NUM2INT, NUM2LL, INT2NUM, UINT2NUM),
	  (LONG2NUM, ULONG2NUM, NUM2CHR, rb_type_p, rb_special_const_p):
	  GCC specific optimization.

Sun Sep 13 09:38:06 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/prime.rb (EratosthenesGenerator#initialize): call super.
	  (TrialDivisionGenerator, Generator23): ditto.  [ruby-core:25539]

Sun Sep 13 08:30:30 2009  Masaki Suketa  <masaki.suketa@nifty.ne.jp>

	* ext/win32ole/win32ole.c: fix WIN32OLE_TYPELIB.new when the 1st 
	  argument is the non-registered file.

Sun Nov  1 22:04:33 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* test/ruby/test_module.rb (TestModule#test_method_added): new test
	  method. Patch by James M. Lawrence.
	  c.f. [ruby-core:25536], r24867.

Sun Sep 13 01:15:49 2009  Tanaka Akira  <akr@fsij.org>

	* lib/open-uri.rb (URI::FTP#buffer_open): fix the %2F handling.

Sat Sep 12 22:47:24 2009  Tanaka Akira  <akr@fsij.org>

	* lib/open-uri.rb (URI::FTP#buffer_open): use the port specified in
	  the URI.

Sat Sep 12 07:52:59 2009  Masaki Suketa  <masaki.suketa@nifty.ne.jp>

	* ext/win32ole/win32ole.c (EVENTSINK_Invoke): initialize result
	  variant value.

Fri Sep 11 10:38:33 2009  URABE Shyouhei  <shyouhei@ruby-lang.org>

	* lib/net/http.rb (Net::HTTPHeader::encode_kvpair): also call to_s
	  to k.  A patch from swdyh <youhei@gmail.com>
	  http://github.com/swdyh/ruby/tree/c847f43c2ccb679b9ff728f8b1b16c6ceeb57f39

Fri Sep 11 09:45:11 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dln.c (aix_loaderror): get rid of using uninitialized value in the
	  case loadquery fails.  fixed wrong index variable usage.  see
	  [ruby-core:25479].

Fri Sep 11 01:14:00 2009  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/net/http.rb (fetch): rdoc fix, patch by Arthur Schreiber.
	  [ruby-core:18309].

Thu Sep 10 21:22:01 2009  Tanaka Akira  <akr@fsij.org>

	* test/dl/test_cptr.rb (test_free=): test SEGV at first.
	  [ruby-dev:39269]

Tue Mar  3 15:05:19 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/dl/lib/dl/value.rb (DL::ValueUtil#wrap_arg): NULL for nil.

Tue Sep  8 08:32:30 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/dl/test_{cfunc,ptr}.rb: added tests from Aaron Patterson.
	  see [ruby-dev:39249].

Tue Mar  3 15:03:19 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/dl: moved from ext/dl/test.

Sat Sep  5 10:38:46 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_compile_each): &&= and ||= should return rhs.
	  [ruby-dev:39163] (#1996), [ruby-core:25143]

Fri Sep  4 04:46:08 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/webrick/httpservlet/abstract.rb (do_OPTIONS): method names
	  are symbols now.  [ruby-core:24580]

Sun Mar 15 09:17:26 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (.y.c): use SRC_FILE which contains slashes instead of
	  backslashes.  [ruby-core:22891]

Tue Sep  1 19:56:28 2009  Koichi Sasada  <ko1@atdot.net>

	* vm_eval.c (eval_string_with_cref): fix to check local_table_size.
	  [ruby-dev:39205] [Bug #2024]

Sun Aug 30 16:38:56 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (rb_enc_symname2_p): not depend on nul terminator.

Sun Aug 30 01:15:31 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/zlib/zlib.c (gzfile_read_all): use gzfile_newstr;
	  set and convert its encoding. [ruby-dev:38304]

Thu Aug 27 18:31:07 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_method.c (rb_remove_method_id): exported.

	* numeric.c (num_sadded): fix for non-ascii method name.

Thu Aug 27 08:16:34 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/strscan/strscan.c (strscan_set_string): set string should not be
	  dupped or frozen, because freezing it causes #concat method failure,
	  and unnecessary to dup without freezing.  a patch from Aaron
	  Patterson at [ruby-core:25145].

Wed Aug 26 12:36:58 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm.c (collect_local_variables_in_env): skips internal variables.
	  [ruby-core:25125]

Mon Aug 24 16:35:57 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* st.c (st_delete_safe): deals with packed entries.
	  [ruby-core:25080]

	* st.c (st_cleanup_safe): ditto.  [ruby-core:25081]

Sun Aug 23 00:56:13 2009  Tanaka Akira  <akr@fsij.org>

	* thread.c (rb_thread_schedule): don't recur infinitely.
	  (rb_threadptr_execute_interrupts): ditto.
	  [ruby-dev:38060]

Sat Aug 22 00:03:19 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* thread.c (rb_check_deadlock): decrease number of sleepers before
	  deadlock detection because the deadlock exception makes main thread
	  run.  [ruby-dev:39142]

Fri Aug 21 15:01:35 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/readline/readline.c (readline_readline): use rb_prep_terminal
	  only on Windows.

Thu Aug 20 14:39:47 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/readline/readline.c (Init_readline): add rl_prep_terminal(1).
	  insited by jitte [ruby-list:43546]

Thu Aug 20 08:39:50 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* thread.c (rb_thread_terminate_all): do not ignore interrupt when
	  reaping threads on termination.  [ruby-dev:39107]

Thu Aug 20 01:06:48 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* dir.c (DEFINE_STRUCT_DIRENT): use union to allocate sufficient
	  memory space for Solaris.  a patch from Naohisa GOTO
	  <ngoto at gen-info.osaka-u.ac.jp> in [ruby-dev:39132].
	  [ruby-dev:39062]

	* configure.in (SIZEOF_STRUCT_DIRENT_TOO_SMALL): Solaris dirent
	  check.

Thu Aug 20 23:39:51 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* parse.y (reduce_nodes_gen): preserve NODE_FL_NEWLINE flag during
	  node reducing.  [ruby-core:24463]

Wed Aug 19 02:54:01 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* test/ruby/test_settracefunc.rb (test_return, test_return2): add two
	  tests for [ruby-dev:38701] and [ruby-core:24463].

Wed Aug 19 01:08:34 2009  Yusuke Endoh  <mame@tsg.ne.jp>

	* compile.c (NODE_RETURN): fire return event at explicit return.
	  [ruby-dev:38701]

Tue Aug 18 11:37:24 2009  wanabe  <s.wanabe@gmail.com>

	* vm_insnhelper.c (vm_call_cfunc): ensure hook c-return.
	  [Bug #1588]

	* test/ruby/test_settracefunc.rb (TestSetTraceFunc#test_raise):
	  follow above.

Mon Aug 17 14:35:03 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (lex_get_str, lex_io_gets, rb_parser_compile_string):
	  must be ascii compatible.

Sun Aug 16 23:58:22 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (yylex): should dispatch scan-event even when follows
	  just after delayed-token.  [ruby-dev:37855] [Bug #1071]

Sun Aug 16 15:25:26 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/csv.rb: Change magic comment to US-ASCII in order to
	  make literals as US-ASCII.

Sun Aug 16 10:45:10 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* regparse.c (parse_char_class, parse_exp, parse_branch),
	  (parse_subexp): fixed memory leak.  a patch from Ralf Junker
	  <ralfjunker AT gmx.de> at [ruby-core:24921].

Sun Aug 16 01:10:00 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* regparse.c (add_ctype_to_cc_by_range): fix the first
	  character bigger than sb_out was dropped.

	* test/ruby/test_regexp.rb (TestRegexp#test_posix_bracket):
	  add tests for above.

Fri Aug 14 14:31:33 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (rubyhdrdir): fixed typo.  [ruby-dev:39079]

Fri Aug 14 00:29:22 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* doc/ChangeLog-1.8.0: add forgotten entry contributed by
	  TAKAHASHI Kaoru.  [ruby-dev:39065]

Fri Aug 14 00:19:49 2009  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/delegate.rb (Delegator#method_missing): __FILE__ may contain
	  multi-byte characters.  a patch from Kenta Murata in [ruby-dev:39066].

Thu Aug 13 21:01:03 2009  wanabe  <s.wanabe@gmail.com>

	* vm.c (vm_exec): returning from lambda runs ensure section.
	  [Bug #1729]

Wed Aug 12 15:52:04 2009  NARUSE, Yui  <naruse@ruby-lang.org>

	* class.c (rb_define_module_id_under): fix the name.

	* class.c (rb_define_module_under): fix for prevvious changes.

Wed Aug 12 15:32:16 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* class.c (rb_define_class_id_under, rb_define_module_id_under):
	  new functions to define a nested class/module with non-ascii
	  name.

	* struct.c (make_struct): use name with encoding.

	* struct.c (inspect_struct): ditto.  [ruby-core:24849]

Wed Aug 12 Wed Aug 12 14:54:34 2009  Koichi Sasada  <ko1@atdot.net>

	* insns.def, vm.c, vm_insnhelper.c, vm_insnhelper.h: check
	  definition of (classes)#=== for case/when optimization.
	  Fix Bug #1376 [ruby-core:23190].

	* string.c (Init_String), bignum.c (Init_Bignum),
	  numeric.c (Init_Numeric): define String#===, Symbol#===,
	  Bignum#===, Fixnum#===, Float#=== as same as (classes)#==.

Wed Aug 12 12:59:51 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_new_frozen): must not change encoding of frozen
	  shared string.  [ruby-dev:39068]

Fri Oct 23 10:51:04 2009  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* test/ruby/test_m17n.rb (TestM17N#test_sprintf_s):
	  added an assertion for [ruby-list:46274].
	  see also r24506.

Tue Oct 20 17:57:31 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* marshal.c (w_symbol, r_symreal): fixed the order of symbol and
	  its encoding modifier, in order to make the dump readable from
	  1.8.  [ruby-dev:39515]

Mon Aug 10 21:45:26 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>
 
 	* include/ruby/intern.h (rb_path2class): no deprecation.

Mon Aug 10 06:55:45 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* marshal.c (class2path, w_unique, w_extended, w_class, w_uclass):
	  deal with non-ascii class path.  [ruby-core:24790]

	* marshal.c (r_unique, path2class, path2module, obj_alloc_by_path),
	  (r_object0): ditto.

	* variable.c (rb_path_to_class): new encoding-aware function to
	  get a class from its name.

Sat Aug  8 06:18:29 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* marshal.c (w_symbol r_symlink, r_symbol, r_object0): fix for
	  non-ascii symbols.  loading such symbols can cause segfaults in
	  older versions.  [ruby-core:24788]

Sun Aug  9 07:25:07 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/ripper/eventids2.c (token_to_eventid): added
	  keyword_do_LAMBDA.  [ruby-dev:39049]

Fri Aug  7 03:22:50 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (rb_exc_raise, rb_exc_fatal): nil is used to reraise.

Wed Aug  5 12:54:00 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (rb_exc_raise, rb_exc_fatal): require exception object.
	  [ruby-core:24767]

Fri Aug  7 01:49:41 2009  Akinori MUSHA  <knu@iDaemons.org>

	* ext/digest/sha2/sha2.c: The ULL suffix is not supported by
	  pre-C99 compilers, so resurrect the ULL() macro to regain
	  portability. [ruby-dev:39032]

Fri Aug  7 01:35:26 2009  Akinori MUSHA  <knu@iDaemons.org>

	* ext/digest/*/extconf.rb: inttypes.h and unistd.h need not be
	  checked here. [ruby-dev:39032]

Thu Aug  6 21:18:15 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/digest/sha2/lib/sha2.rb: should require sha2.so.

Thu Aug  6 21:11:40 2009  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/digest/sha2/sha2.c (*_Final): typos.

Thu Aug  6 19:46:56 2009  Akinori MUSHA  <knu@iDaemons.org>

	* ext/digest/sha2/sha2.h (BYTE_ORDER): Define BYTE_ORDER as
	  necessary. [ruby-dev:39029]

Thu Aug  6 01:37:20 2009  Akinori MUSHA  <knu@iDaemons.org>

	* ext/digest/sha2/sha2.[ch]: Update to 1.0 RELEASE which fixes an
	  off-by-one bug in SHA-256 hashing.  Reduce differences from
	  the original while at it. [Bug #1799]

Thu Aug  6 16:25:08 2009  Nobuyoshi Nakada  <nobu@ruby-lang.org>

